<template>
    <div class="container w-80 mx-auto mt-36">
        <div v-if="authorized" class="flex">
            <div class="container w-36 h-36 mr-10">
                <img class="w-100 h-100" src='https://avataaars.io/?avatarStyle=Circle&topType=LongHairBigHair&accessoriesType=Wayfarers&hairColor=SilverGray&facialHairType=MoustacheMagnum&facialHairColor=Black&clotheType=ShirtVNeck&clotheColor=PastelYellow&eyeType=Squint&eyebrowType=UpDown&mouthType=Twinkle&skinColor=Black'
                />
            </div>
            <div class="container w-36 flex flex-col justify-around">
                <p>{{ email }}</p>
                <p>{{ username }}</p>
            </div>
        </div>
        <div v-else>
            <p>Unauthorized</p>
        </div>
        <div class="relative h-3">
            <p v-if="tokenError" class="absolute w-full text-center text-sm text-red-700">
                {{ tokenError }}. Please, try again.
            </p>
        </div>
    </div>
</template>

<script>
import { mapState } from 'vuex';

const baseURL = "http://localhost:3001/";

export default {
    data() {
        return {
            email: null,
            username: null,
            tokenError: "",
        };
    },
    computed: {
        ...mapState({
            userId: state => state.userId,
        }),
        authorized() {
            return (this.userId && this.$route.params.id === this.userId);
        },
    },
    mounted() {
        if (!this.$store.state.token) {
            this.$router.push({path: "/sign-up"});
        }
        this.getUserData();
    },
    methods: {
        async getUserData() {
            this.$axios.setToken(this.$store.state.token, 'Bearer');

            try {
                const authURL = baseURL + "600/users/" + this.userId;
                const res = await this.$axios.get(authURL);
                this.email = res.data.email;
                this.username = res.data.username;
            } catch (e) {
                this.tokenError = e.response.data;
            }
        },
    },
};
</script>
